-- Sort Spill

-- Create xEvent session
CREATE EVENT SESSION [SortSpills] ON SERVER 
ADD EVENT sqlserver.sort_warning(
    ACTION(sqlserver.sql_text))
ADD TARGET package0.ring_buffer(SET max_memory=(25600))
--ADD TARGET package0.event_file(SET filename=N'H:\Demo\SortSpills.xel',max_file_size=(50),max_rollover_files=(2))
WITH (MAX_MEMORY=4096 KB,EVENT_RETENTION_MODE=ALLOW_SINGLE_EVENT_LOSS,MAX_DISPATCH_LATENCY=30 SECONDS,MAX_EVENT_SIZE=0 KB,MEMORY_PARTITION_MODE=NONE,TRACK_CAUSALITY=OFF,STARTUP_STATE=OFF)
GO


USE AdventureWorks2014
GO 
--Execute  
DBCC FREEPROCCACHE
GO
ALTER EVENT SESSION [SortSpills] ON SERVER STATE = START
GO
SELECT *
FROM Sales.SalesOrderDetail SOD
INNER JOIN Production.Product P ON SOD.ProductID = P.ProductID
ORDER BY Style
GO
ALTER EVENT SESSION [SortSpills] ON SERVER STATE = STOP
GO

-- also repeat with set statistics io on, to show sort's worktable statistics